local dndBanner = "<BSW> "
local dndString = dndBanner .. "I'm busy fighting%s."
local combatEndedString = "Combat ended."
local successString = " This boss is now history !"
local wipeString = " That's a wipe ! :( "
local bossNameString = ""
local startTime = ""

local diffRef = {[0] = "", [1] = "[5]", [2] = "[5H]", [3] = "[10]", [4] = "[25]", [5] = "[10H]", [6] = "[25H]", [7] = "[LFR]", [8] = "[Challenge]", [9] = "[40]", [14] = "[Normal]", [15] = "[Heroic]", [16] = "[Mythic]", [17] = "[LFR]", [23] = "[5-Mythic]", [24] = "[Timewalker]"}

local frame = CreateFrame("Frame")
local addonName = ...
local pname = UnitName("player")
local whisperers = {}
local bosses = {}
local bossFormat = " %s (%.2f%%)"

--- Pads str to length 2 with char from left
local function lpad_2(str, char)
	if char == nil then char = ' ' end
	if (str < 10) then
		str = string.rep(char, 1) .. str
	end
	return str
end

function frame:ENCOUNTER_START(encounterID, name, difficulty, size, success)
	bossNameString = name
	startTime = time()
	-- print(startTime)
	-- print(bossNameString)
end
function frame:ENCOUNTER_END(encounterID, name, difficulty, size, success)
	local endTime = time()
	local diffTime = endTime - startTime
	--a % b == a - math.floor(a/b)*b -- a modulo b
	local minutes = math.floor(diffTime/60)
	minutes = lpad_2(minutes,0)
	local seconds = diffTime - math.floor(diffTime/60)*60 -- modulo 60	
	seconds = lpad_2(seconds,0) -- modulo 60	
	local announceTimeString = " ("..minutes..":"..seconds..")"
	local strStatus = ""
	if (minutes and seconds) then
		strStatus = announceTimeString		
	end
	-- print("("..minutes..":"..seconds..")")
	-- print(diffTime)
	if success == 1 then
		strStatus = strStatus .. successString
	else
		strStatus = strStatus .. wipeString .. bossNameString .. " : "
		if #bosses ~= 0 then
			for i, value in ipairs(bosses) do
				if (bosses[i].hp) then 
					strStatus = strStatus .. bossFormat:format(bosses[i].bossName, bosses[i].hp)
				end
			end
		end
	end
		
	for player in pairs(whisperers) do
		if type(player) == "string" then
			SendChatMessage(dndBanner .. combatEndedString .. strStatus, "WHISPER", nil, player)
			print("[BSW] Auto-responded to "..player)
		end
		if type(player) == "number" then
			BNSendWhisper(player, dndBanner .. combatEndedString .. strStatus)
			local pID, pName, bTag, isBTagPresence, toonName, toonID, client, isOn, lastOn, isAFK, isDND, msgText, noteText, isRIDFriend, broadcastTime, canSoR = BNGetFriendInfoByID(player)
			print("[BSW] Auto-responded to "..pName)
		end
		table.remove(whisperers, 1)
	end
	wipe(whisperers)
	wipe(bosses)
end

function frame:PLAYER_REGEN_ENABLED()
	if not(UnitExists("boss1")) then
		local endTime = time()
		local diffTime = endTime - startTime
		--a % b == a - math.floor(a/b)*b -- a modulo b
		local minutes = math.floor(diffTime/60)
		minutes = lpad_2(minutes,0)
		local seconds = diffTime - math.floor(diffTime/60)*60 -- modulo 60	
		seconds = lpad_2(seconds,0)
		local announceTimeString = " ("..minutes..":"..seconds..")"
		local strStatus = ""
		if (minutes and seconds) then
			strStatus = announceTimeString
		end
		-- We only use this if players were not already whispered after ENCOUNTER_END event AND if there is no boss left
		for player in pairs(whisperers) do
			if type(player) == "string" then
				SendChatMessage(dndBanner .. bossNameString .. " : " .. combatEndedString .. strStatus, "WHISPER", nil, player)
				print("[BSW] Auto-responded to "..player)
			end
			if type(player) == "number" then
				BNSendWhisper(player, dndBanner .. bossNameString .. ":" .. combatEndedString .. strStatus)
				print("[BSW] Auto-responded to "..player)
			end
			table.remove(whisperers, 1)
		end
		wipe(whisperers)
		wipe(bosses)
	end
end

function frame:CHAT_MSG_WHISPER(msg, sender, _, _, _, gm)
	if not UnitExists("boss1") then return end
	if type(sender) ~= "string" or sender == pname or UnitInRaid(sender) or gm == "GM" then return end
	if not whisperers[sender] or msg == "status" then
		whisperers[sender] = true		
		local str = " "
		local bossDiff = diffRef[select(3, GetInstanceInfo())]
		if not(bossDiff) then bossDiff = "N/A" end
		-- if #bosses ~= 0 then wipe(bosses) end
		for i = 1, MAX_BOSS_FRAMES do
			if UnitExists("boss" .. i) then
				bosses[i] = {bossName = UnitName("boss" .. i); hp = tonumber(string.format("%." .. (2 or 0) .. "f", UnitHealth("boss" .. i) / UnitHealthMax("boss" .. i) * 100))}
				else bosses[i] = {}
			end
		end
		if #bosses == 0 then return end
		str = str .. bossDiff .. bossNameString .. " : "
		for i, value in ipairs(bosses) do
			if (bosses[i].hp) then 
				str = str .. bossFormat:format(bosses[i].bossName, bosses[i].hp)
			end
		end
		SendChatMessage(dndString:format(str), "WHISPER", nil, sender)
		print("[BSW] Auto-responded to "..sender)
	end
end

function frame:CHAT_MSG_BN_WHISPER(msg, sender, _, _, _, _, _, _, _, _, _, _, pID, _)
	if not UnitExists("boss1") then return end
	if type(pID) ~= "number" or BNIsSelf(pID) then return end
	if not whisperers[pID] or msg == "status" then
		whisperers[pID] = true
		local str = " "
		local bossDiff = diffRef[select(3, GetInstanceInfo())]
		-- if #bosses ~= 0 then wipe(bosses) end
		for i = 1, MAX_BOSS_FRAMES do
			if UnitExists("boss" .. i) then
				bosses[i] = {bossName = UnitName("boss" .. i); hp = tonumber(string.format("%." .. (2 or 0) .. "f", UnitHealth("boss" .. i) / UnitHealthMax("boss" .. i) * 100))}
				else bosses[i] = {}
			end
		end
		if #bosses == 0 then return end
		if not(bossDiff) then bossDiff = "N/A" end
		str = str .. bossDiff .. bossNameString .. " : "
		for i, value in ipairs(bosses) do
			if (bosses[i].hp) then 
				str = str .. bossFormat:format(bosses[i].bossName, bosses[i].hp)
			end
		end
		BNSendWhisper(pID, dndString:format(str))
		print("[BSW] Auto-responded to "..sender)
	end
end

function frame:COMBAT_LOG_EVENT_UNFILTERED(timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags)
	if(event=="UNIT_DIED" and (UnitInRaid(destName) or UnitInParty(destName))) then 
	--When a player die, we update boss status
		-- if #bosses ~= 0 then wipe(bosses) end
		for i = 1, MAX_BOSS_FRAMES do
			if UnitExists("boss" .. i) then
				bosses[i] = {bossName = UnitName("boss" .. i); hp = tonumber(string.format("%." .. (2 or 0) .. "f", UnitHealth("boss" .. i) / UnitHealthMax("boss" .. i) * 100))}
				else bosses[i] = {}
			end
		end
	end
end

frame:SetScript("OnEvent", function(self, event, msg, ...) self[event](self, msg, ...) end)
frame:RegisterEvent("CHAT_MSG_WHISPER")
frame:RegisterEvent("CHAT_MSG_BN_WHISPER")
frame:RegisterEvent("PLAYER_REGEN_ENABLED")
frame:RegisterEvent("ENCOUNTER_END")
frame:RegisterEvent("ENCOUNTER_START")
frame:RegisterEvent("ADDON_LOADED")
frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")

function frame:ADDON_LOADED(msg)
	if msg ~= addonName then return end
	self:UnregisterEvent("ADDON_LOADED")
	if not SBW_DisableChatFilter then
		local bannerTest = "^" .. dndBanner
		ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER_INFORM", function(self, event, msg)
			if msg:find(bannerTest) then return true end
		end)
	end
end
